#include <stdlib.h>
#include <string.h>

#include "../unity/unity.h"
#include "./fib_lib.h"

void setUp(void) {}
void tearDown(void) {}

void test_fib_slow_0(void) { TEST_ASSERT_EQUAL_INT(0, fib_slow(0)); }

void test_fib_slow_1(void) { TEST_ASSERT_EQUAL_INT(1, fib_slow(1)); }

void test_fib_slow_10(void) { TEST_ASSERT_EQUAL_INT(55, fib_slow(10)); }

void test_fib_fast_0(void) { TEST_ASSERT_EQUAL_INT(0, fib_fast(0)); }

void test_fib_fast_1(void) { TEST_ASSERT_EQUAL_INT(1, fib_fast(1)); }

void test_fib_fast_10(void) { TEST_ASSERT_EQUAL_INT(55, fib_fast(10)); }

void test_fib_fast_slow(void) {
  for (int n = 0; n < 30; ++n) {
    TEST_ASSERT_EQUAL_INT(fib_slow(n), fib_fast(n));
  }
}

int main(void) {
  UNITY_BEGIN();
  RUN_TEST(test_fib_slow_0);
  RUN_TEST(test_fib_slow_1);
  RUN_TEST(test_fib_slow_10);
  RUN_TEST(test_fib_fast_0);
  RUN_TEST(test_fib_fast_1);
  RUN_TEST(test_fib_fast_10);
  RUN_TEST(test_fib_fast_slow);
  return UNITY_END();
}
